(define "set-impregnability"
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
      {amount 10
      }
    }
    {impregnability %status}
  }
)

(define "set-invulnerability-status"
  {"switch"
    {"case"
      {condition
        {type cmp_i}
        {var "cheatmenu-invulnerability$"}
        {op "=="}
        {value 1}
      }
      ("set-impregnability" status(disabled))
    }
    {"case"
      {condition
        {type cmp_i}
        {var "cheatmenu-invulnerability$"}
        {op "=="}
        {value 2}
      }
      ("set-impregnability" status(full))
    }
    {"default"}
  }
)

(define "clear-spawned-tags"
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove cheatmenu_spawned}
  }
)

(define "clear-enemy-tags"
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {tag_remove cheatmenu_enemy}
  }
)

(define "assign-to-player"
  {"actor_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {control user}
    {fire_mode open}
    {move_mode free}
    {weapon_prepare on}
    {ai_move
      {mode disable}
    }
    {make_squad}
  }
  {"delay"
    {time 0.1}
  }
  ("apply-ai-mode")
  ("set-invulnerability-status")
  {"delay"
    {time 0.1}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_add cheatmenu_created_unit}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove cheatmenu_spawned}
  }
)

(define "assign-to-enemy"
  {"actor_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {control AI}
    {fire_mode open}
    {move_mode free}
    {weapon_prepare on}
    {ai_move
      {mode enable}
    }
    {movement
      {speed assault}
    }
    {ai
      {advance_ratio "2"}
    }
    {make_squad}
  }
  {"delay"
    {time 0.1}
  }
  ("choose-enemy-player")
  {"delay"
    {time 0.1}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {tag_add cheatmenu_enemy_infantry}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {tag_remove cheatmenu_enemy}
  }
)

(define "set-current-player"
  {"player"
    {selector
       {tag cheatmenu_spawned}
    }
    {operation set}
    {player "%player"}
  }
  {"player"
    {selector
       {tag cheatmenu_passenger}
    }
    {operation set}
    {player "%player"}
  }
)


(define "set-current-enemy-player"
  {"player"
    {selector
       {tag cheatmenu_enemy}
       {state "not dead"}
    }
    {operation set}
    {player "%player"}
  }
  {"player"
    {selector
       {tag cheatmenu_enemy_passenger}
       {state "not dead"}
    }
    {operation set}
    {player "%player"}
  }
)

(define "enemy-attack-player"
  {"action"
    {selector
      {tag cheatmenu_enemy}
    }
    {drop orders}
    {action attack}
    {target
      {source advanced}
      {ignore_captured_by_user 0}
      {group
        {select
            {player "%player"}
        }
        {include
          {prop
            {prop human}
          }
        }
        {exclude
          {tag
            {tag hidden}
          }
          {state
            {state dead}
          }
          {state
            {state linked}
          }
        }
      }
      {group
        {select
          {player "%player"}
        }
        {include
          {prop
            {prop vehicle}
          }
          {state
            {state inhabited}
          }
        }
        {exclude
          {tag
            {tag hidden}
          }
          {state
            {state inactive}
          }
        }
      }
      {sort
        {type entity}
        {entity
          {ignore_captured_by_user 0}
          {type human}
          {state "not dead"}
        }
      }
    }
  }
)

(define "player-attack-enemy"
  {"action"
    {selector
      {tag cheatmenu_spawned}
    }
    {drop orders}
    {action attack}
    {target
      {source advanced}
      {ignore_captured_by_user 0}
      {group
        {select
            {player "%player"}
        }
        {include
          {prop
            {prop human}
          }
        }
        {exclude
          {tag
            {tag hidden}
          }
          {state
            {state dead}
          }
          {state
            {state linked}
          }
        }
      }
      {group
        {select
          {player "%player"}
        }
        {include
          {prop
            {prop vehicle}
          }
          {state
            {state inhabited}
          }
        }
        {exclude
          {tag
            {tag hidden}
          }
          {state
            {state inactive}
          }
        }
      }
      {sort
        {type entity}
        {entity
          {ignore_captured_by_user 0}
          {type human}
          {state "not dead"}
        }
      }
    }
  }
)

(define "choose-player-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-player$"}
      {op "=="}
      {value %player}
    }
    ("set-current-player" player(%player))
  }
)

(define "choose-enemy-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-enemy-player$"}
      {op "=="}
      {value %player}
    }
    ("set-current-enemy-player" player(%player))
  }
)

(define "choose-player"
  {"switch"
    ("choose-player-condition" player(0))
    ("choose-player-condition" player(1))
    ("choose-player-condition" player(2))
    ("choose-player-condition" player(3))
    ("choose-player-condition" player(4))
    ("choose-player-condition" player(5))
    ("choose-player-condition" player(6))
    ("choose-player-condition" player(7))
    ("choose-player-condition" player(8))
    ("choose-player-condition" player(9))
    ("choose-player-condition" player(10))
    ("choose-player-condition" player(11))
    ("choose-player-condition" player(12))
    ("choose-player-condition" player(13))
    ("choose-player-condition" player(14))
    ("choose-player-condition" player(15))
    ("choose-player-condition" player(16))
    {"default"
      ("set-current-player" player(0))
    }
  }
)

(define "choose-enemy-player"
  {"switch"
    ("choose-enemy-condition" player(0))
    ("choose-enemy-condition" player(1))
    ("choose-enemy-condition" player(2))
    ("choose-enemy-condition" player(3))
    ("choose-enemy-condition" player(4))
    ("choose-enemy-condition" player(5))
    ("choose-enemy-condition" player(6))
    ("choose-enemy-condition" player(7))
    ("choose-enemy-condition" player(8))
    ("choose-enemy-condition" player(9))
    ("choose-enemy-condition" player(10))
    ("choose-enemy-condition" player(11))
    ("choose-enemy-condition" player(12))
    ("choose-enemy-condition" player(13))
    ("choose-enemy-condition" player(14))
    ("choose-enemy-condition" player(15))
    ("choose-enemy-condition" player(16))
    {"default"
      ("set-current-enemy-player" player(1))
    }
  }
)

(define "clone-infantry"
  {"actor_to_waypoint"
    {selector
      {source advanced}
        {group
          {select
            {tag
              {tag %tag}
            }
        }
        {include
            {state
              {state inactive}
            }
          }
        }
        {amount 1
        }
    }

    {waypoint "5500"}
    {clone}
    {approach "safe teleport & rotate"}
  }
  {"entity_state"
    {selector
      {source advanced}
      {group
        {select
          {tag
            {tag cheatmenu_infantry}
          }
        }
        {exclude
          {state
            {state inactive}
          }
        }
      }
    }
    {tag_remove cheatmenu_infantry}
    {tag_add cheatmenu_spawned}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove %tag}
  }
  ("choose-player")
)

(define "clone-enemy-infantry"
  {"actor_to_waypoint"
    {selector
      {source advanced}
        {group
          {select
            {tag
              {tag %tag}
            }
        }
        {include
            {state
              {state inactive}
            }
          }
        }
        {amount 1
        }
    }

    {waypoint "%waypoint"}
    {clone}
    {approach "safe teleport & rotate"}
  }
  {"entity_state"
    {selector
      {source advanced}
      {group
        {select
          {tag
            {tag cheatmenu_infantry}
          }
        }
        {exclude
          {state
            {state inactive}
          }
        }
      }
    }
    {tag_remove cheatmenu_infantry}
    {tag_add cheatmenu_enemy}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {tag_remove %tag}
  }
)

(define "spawn-unit"
  {"spawn"
    {entity %name}
    {waypoint "5500"}
  }
)

(define "spawn-at-place"
  {"spawn"
    {entity %name}
    {waypoint "5500"}
    {disable_random_spawn_position}
  }
)

(define "spawn-at-place-waypoint"
  {"spawn"
    {entity %name}
    {waypoint "%waypoint"}
    {disable_random_spawn_position}
  }
)

(define "clone-vehicle"
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove cheatmenu_spawned}
  }
  {"actor_to_waypoint"
    {selector
      {source advanced}
        {group
          {select
            {tag
              {tag %tag}
            }
        }
        {include
            {state
              {state inactive}
            }
          }
        }
        {amount 1
        }
    }
    {waypoint "5500"}
    {clone}
    {approach "teleport"}
  }
  {"entity_state"
    {selector
      {source advanced}
      {group
        {select
          {tag
            {tag cheatmenu_vehicle}
          }
        }
        {exclude
          {state
            {state inactive}
          }
        }
      }
    }
    {tag_remove cheatmenu_vehicle}
    {tag_add cheatmenu_spawned}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove %tag}
  }
  ("choose-player")
  ("set-invulnerability-status")
  {"delay"
    {time 0.1}
  }
  ("apply-ai-mode")
  {"delay"
    {time 0.2}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_add cheatmenu_created_unit}
  }
  {"delay"
    {time 0.1}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_spawned}
    }
    {tag_remove cheatmenu_spawned}
  }
)

(define "apply-ai-mode"
  {"switch"
    {"case"
      {condition
        {type cmp_i}
        {var "cheatmenu-aimode$"}
        {op "=="}
        {value 2}
      }
      {"actor_state"
        {selector
          {tag cheatmenu_spawned}
        }
        {control AI}
        {fire_mode open}
        {move_mode free}
        {weapon_prepare on}
        {ai_move
          {mode enable}
        }
        {movement
          {speed assault}
          {type normal}
        }
        {ai
          {advance_ratio "2"}
        }
      }
      {"con"
        {text "AI Mode: AI on"}
      }
    }
    {"case"
      {condition
        {type cmp_i}
        {var "cheatmenu-aimode$"}
        {op "=="}
        {value 1}
      }
      {"actor_state"
        {selector
          {tag cheatmenu_spawned}
        }
        {control user}
        {fire_mode open}
        {move_mode hold}
        {weapon_prepare on}
        {ai_move
          {mode disable}
        }
      }
      {"con"
        {text "AI Mode: AI off"}
      }
    }
    {"default"
      {"actor_state"
        {selector
          {tag cheatmenu_spawned}
        }
        {control user}
        {fire_mode open}
        {move_mode hold}
        {weapon_prepare on}
        {ai_move
          {mode disable}
        }
      }
      {"con"
        {text "AI Mode: Default"}
      }
    }
  }
)

(define "clone-enemy-vehicle"
  {"actor_to_waypoint"
    {selector
      {source advanced}
        {group
          {select
            {tag
              {tag %tag}
            }
        }
        {include
            {state
              {state inactive}
            }
          }
        }
        {amount 1
        }
    }
    {waypoint "%waypoint"}
    {clone}
    {approach "safe teleport & rotate"}
  }
  {"entity_state"
    {selector
      {source advanced}
      {group
        {select
          {tag
            {tag cheatmenu_enemy_spawned}
          }
        }
        {exclude
          {state
            {state inactive}
          }
        }
      }
    }
    {tag_remove cheatmenu_enemy_spawned}
    {tag_add cheatmenu_enemy}
  }
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
      {amount 10
      }
    }
    {tag_remove %tag}
  }
  {"actor_state"
    {selector
      {tag cheatmenu_enemy}
      {amount 10
      }
    }
    {control AI}
    {fire_mode open}
    {move_mode free}
    {weapon_prepare on}
    {ai_move
      {mode enable}
      {enable_on enemy}
    }
    {movement
      {speed fast}
    }
    {ai
      {advance_ratio 1}
    }
  }
  {"delay"
    {time 0.1}
  }
  ("choose-enemy-player")
  ("apply-player" operation(enemy-attack-player))
  {"entity_state"
    {selector
      {tag cheatmenu_enemy}
    }
    {tag_remove cheatmenu_enemy}
    {tag_add cheatmenu_enemy_vehicle}
  }
)

(define "spawn-one"
  ("spawn-unit" name(%one))
)

(define "reset-event"
  {"event"
    {event %name}
    {mode reset}
    {delay 0}
  }
)

(define "set-event"
  {"event"
    {event %name}
    {mode set}
    {delay 0}
  }
)

(define "hide-icon"
  {"reinforcement"
    {operation hide}
    {name %name}
  }
)

(define "show-icon"
  {"reinforcement"
    {operation show}
    {name %name}
  }
)

(define "add-icon"
  {%name
    {state hidden}
    {text %text}
    {image %image}
    {hint %hint}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
  }
)

(define "add-spawn-icon"
  {%name
    {state hidden}
    {text %text}
    {image %image}
    {hint %hint}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5500"}
  }
)

(define "add-spawn-icon-preview"
  {%name
    {state hidden}
    {text %text}
    {image %image}
    {hint %hint}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5500"}
    {previewEntity %preview}
  }
)

(define "add-inventory-icon"
  {%name
    {state hidden}
    {text %text}
    {image %image}
    {hint %hint}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5605"}
    {previewEntity cheatmenu_inventory_marker}
  }
)

(define "add-enemy-icon"
  {%name
    {state hidden}
    {text %text}
    {image %image}
    {hint %hint}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "%waypoint"}
  }
)

(define "add-vehicle-icon"
  {%name
    {state hidden}
    {text "desc/entity/%image"}
    {image "%image"}
    {hint "desc/entity/%image"}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5500"}
  }
)

(define "enemy-vehicle-icon"
  {%name
    {state hidden}
    {text "desc/entity/%image"}
    {image "%image"}
    {hint "desc/entity/%image"}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5606"}
  }
)

(define "add-infantry-icon"
  {%name
    {state hidden}
    {text "desc/squad/%image(%faction)"}
    {image "%image(%faction)"}
    {hint "desc/squad/%image(%faction)"}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5500"}
  }
)

(define "enemy-squad-icon"
  {%name
    {state hidden}
    {text "desc/squad/%image(%faction)"}
    {image "%image(%faction)"}
    {hint "desc/squad/%image(%faction)"}
    {count -1}
    {score 0}
    {delay 0}
    {eventStart %event}
    {waypoint "5606"}
  }
)

(define "add-faction-trigger"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("set-event" name("hide:cheatmenu/units/factions"))
      {"set_i"
        {var "cheatmenu-faction$"}
        {op "="}
        {value %faction}
      }
      ("set-event" name("click:cheatmenu/units"))
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-unit-trigger"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("spawn-one" one(%unit))
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-vehicle-trigger"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clone-vehicle" tag("%faction_%unit"))
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-vehicle-trigger"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clone-enemy-vehicle" tag("%faction_%unit_enemy") waypoint(5606))
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-2"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-3"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("clone-infantry" tag("%faction_%three"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-4"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("clone-infantry" tag("%faction_%three"))
      ("clone-infantry" tag("%faction_%four"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-5"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("clone-infantry" tag("%faction_%three"))
      ("clone-infantry" tag("%faction_%four"))
      ("clone-infantry" tag("%faction_%five"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-6"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("clone-infantry" tag("%faction_%three"))
      ("clone-infantry" tag("%faction_%four"))
      ("clone-infantry" tag("%faction_%five"))
      ("clone-infantry" tag("%faction_%six"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "add-squad-trigger-8"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-spawned-tags")
      ("clone-infantry" tag("%faction_%one"))
      ("clone-infantry" tag("%faction_%two"))
      ("clone-infantry" tag("%faction_%three"))
      ("clone-infantry" tag("%faction_%four"))
      ("clone-infantry" tag("%faction_%five"))
      ("clone-infantry" tag("%faction_%six"))
      ("clone-infantry" tag("%faction_%seven"))
      ("clone-infantry" tag("%faction_%eight"))
      ("assign-to-player")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "condition-event"
  {condition
    {terms
      {"1.event"
        {id %name}
      }
    }
  }
)

(define "arm-event"
  {"trigger"
    {name %name}
  }
)

(define "faction-operation-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-faction$"}
      {op "=="}
      {value %value}
    }
    ("%operation" faction(%faction))
  }
)

(define "faction-operation"
  {"switch"
    ("faction-operation-condition" operation(%operation) value(1) faction(usa))
    ("faction-operation-condition" operation(%operation) value(2) faction(uaf))
    ("faction-operation-condition" operation(%operation) value(3) faction(rus))
    ("faction-operation-condition" operation(%operation) value(4) faction(reb))
    ("faction-operation-condition" operation(%operation) value(5) faction(grm))
    ("faction-operation-condition" operation(%operation) value(6) faction(ger))
    {"default"}
  }
)

(define "show-player-faction-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-faction$"}
      {op "=="}
      {value %value}
    }
    ("show-icon" name(%name))
  }
)

(define "show-player-faction-icon"
  {"switch"
    ("show-player-faction-condition" value(1) name("cheatmenu-faction-selected-usa"))
    ("show-player-faction-condition" value(2) name("cheatmenu-faction-selected-uaf"))
    ("show-player-faction-condition" value(3) name("cheatmenu-faction-selected-russia"))
    ("show-player-faction-condition" value(4) name("cheatmenu-faction-selected-rebels"))
    ("show-player-faction-condition" value(5) name("cheatmenu-faction-selected-grm"))
    ("show-player-faction-condition" value(6) name("cheatmenu-faction-selected-germany"))
    {"default"}
  }
)

(define "add-human-entity"
  {Human "mp/%faction/%type" 0x%id
    {TexMod %texmod }
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }
  {Tags "cheatmenu_infantry" "%faction_%type" 0x%id}
)

(define "add-human-passenger"
  {Human "mp/%faction/%type" 0x%id
    {TexMod %texmod }
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }
  {Tags "cheatmenu_passenger" 0x%id}
)

(define "add-vehicle-entity-2"
  {Entity "%type" 0x%id
    {Position 0 0 -2000}
    {TexMod %texmod }
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }

  ("add-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Tags "cheatmenu_vehicle" "%faction_%type" 0x%id}
)

(define "add-custom-entity-1"
  {Entity "%type" 0x%id
    {Position 0 0 -2000}
    {TexMod %texmod }
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }

  ("add-human-passenger" faction(%faction) type(%crewType) id(%crew) texmod(%texmod))
  {Link 0x%crew {0x%id "%role"}}
  {Tags "cheatmenu_vehicle" "%faction_%type" 0x%id}
)

(define "add-custom-entity-2"
  {Entity "%type" 0x%id
    {TexMod %texmod }
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }

  ("add-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  {Link 0x%crewOne {0x%id "%roleOne"}}
  {Link 0x%crewTwo {0x%id "%roleTwo"}}
  {Tags "cheatmenu_vehicle" "%faction_%type" 0x%id}
)

(define "add-vehicle-entity-3"
  {Entity "%type" 0x%id
    {Position 0 0 -2000}
    {TexMod %texmod }
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }

  ("add-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crewSupport) id(%crewThree) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Link 0x%crewThree {0x%id "%roleOne"}}
  {Tags "cheatmenu_vehicle" "%faction_%type" 0x%id}
)

(define "add-vehicle-entity-4"
  {Entity "%type" 0x%id
    {Position 0 0 -2000}
    {TexMod %texmod }
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control user}
      {move_mode hold}
    }
  }

  ("add-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crewSupport) id(%crewThree) texmod(%texmod))
  ("add-human-passenger" faction(%faction) type(%crewSupport) id(%crewFour) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Link 0x%crewThree {0x%id "%roleOne"}}
  {Link 0x%crewFour {0x%id "%roleTwo"}}
  {Tags "cheatmenu_vehicle" "%faction_%type" 0x%id}
)

(define "add-item-entity"
  {Entity "%type" 0x%id
    {Position 0 0 -1000}
    {Impregnability full}
  }
  {Tags "cheatmenu_item" "%type" 0x%id}
)

(define "add-preload-entity"
  {Entity "%type" 0x%id
    {Position 0 0 -1000}
    {Impregnability full}
  }

  {Tags "cheatmenu_preload_item" "%type" 0x%id}
)

(define "add-player-entity"
  {Human %type 0x%id
    {Impregnability full}
    {Player %player}
  }
  {Tags "cheatmenu_player_autoset" "cheatmenu_autoset_%player" 0x%id}
)

(define "add-human-tool"
  {Human "cheatmenu/%type" 0x%id
    {TexMod "desert"}
  }
  {Brain 0x%id
    {Properties
      {control AI}
      {move_mode hold}
    }
  }
  {Tags "cheatmenu_tool" "cheatmenu_%type_tool" 0x%id}
)

(define "apply-player-inventory"
  ("spawn-at-place-waypoint" name("cheatmenu_inventory_marker") waypoint(5605))
  ("set-event" name("setup:cheatmenu/inventory/manager"))
  {"delay"
    {time 1}
  }
  {"loop" 10
    ("populate-player-inventory" item(%item))
  }
  {"entity_state"
    {selector
      {tag cheatmenu_inventory_processed}
    }
    {tag_remove cheatmenu_inventory_processed}
  }
  {"delete"
    {selector
      {tag cheatmenu_inventory_manager}
    }
  }
)

(define "add-trigger-player-inventory"
  {%event
    ("condition-event" name(%event))
    {actions
      ("reset-event" name(%event))
      ("apply-player-inventory" item(%operation))
      ("arm-event" name(%event))
    }
  }
)

(define "call-function"
  {"call"
    {function %name}
  }
)

(define "add-trigger-environment"
  {%event
    ("condition-event" name(%event))
    {actions
      ("reset-event" name(%event))
      {"environment"
          {name %environment}
          {time -1}
          {apply}
      }
      ("arm-event" name(%event))
    }
  }
)

(define "add-trigger-set-player"
  {%event
    ("condition-event" name(%event))
    {actions
      ("reset-event" name(%event))
      {"set_i"
        {var "cheatmenu-player$"}
        {op "="}
        {value %player}
      }
      {"con"
        {text "Setting main Player to %player"}
      }
      ("set-event" name("click:cheatmenu/modifiers/set-player/return"))
      ("arm-event" name(%event))
    }
  }
)

(define "add-trigger-set-enemy-player"
  {%event
    ("condition-event" name(%event))
    {actions
    ("reset-event" name(%event))
      {"set_i"
        {var "cheatmenu-enemy-player$"}
        {op "="}
        {value %player}
      }
      {"con"
        {text "Setting Enemy Player to %player"}
      }
      ("set-event" name("click:cheatmenu/modifiers/set-enemy-player/return"))
      ("arm-event" name(%event))
    }
  }
)