(define "add-enemy-faction-trigger"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("set-event" name("hide:cheatmenu/create-enemy/factions"))
      ("set-event" name("show:cheatmenu/create-enemy"))
      {"set_i"
        {var "cheatmenu-enemy-faction$"}
        {op "="}
        {value %faction}
      }
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "faction-enemy-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-enemy-faction$"}
      {op "=="}
      {value %value}
    }
    ("%operation" faction(%faction))
  }
)

(define "faction-enemy-operation"
  {"switch"
    ("faction-enemy-condition" operation(%operation) value(1) faction(usa))
    ("faction-enemy-condition" operation(%operation) value(2) faction(uaf))
    ("faction-enemy-condition" operation(%operation) value(3) faction(rus))
    ("faction-enemy-condition" operation(%operation) value(4) faction(reb))
    ("faction-enemy-condition" operation(%operation) value(5) faction(grm))
    ("faction-enemy-condition" operation(%operation) value(6) faction(ger))
    {"default"}
  }
)

(define "show-enemy-faction-condition"
  {"case"
    {condition
      {type cmp_i}
      {var "cheatmenu-enemy-faction$"}
      {op "=="}
      {value %value}
    }
    ("show-icon" name(%name))
  }
)

(define "show-enemy-faction-icon"
  {"switch"
    ("show-enemy-faction-condition" value(1) name("cheatmenu-create-enemy-factions-usa"))
    ("show-enemy-faction-condition" value(2) name("cheatmenu-create-enemy-factions-uaf"))
    ("show-enemy-faction-condition" value(3) name("cheatmenu-create-enemy-factions-rus"))
    ("show-enemy-faction-condition" value(4) name("cheatmenu-create-enemy-factions-reb"))
    ("show-enemy-faction-condition" value(5) name("cheatmenu-create-enemy-factions-grm"))
    ("show-enemy-faction-condition" value(6) name("cheatmenu-create-enemy-factions-ger"))
    {"default"}
  }
)

(define "create-enemy-trigger"
  {"click:cheatmenu/create-enemy/%type-vehicles"
    ("condition-event" name("click:cheatmenu/create-enemy/%type-vehicles"))
    {actions
      ("reset-event" name("click:cheatmenu/create-enemy/%type-vehicles"))
      ("faction-enemy-operation" operation(enemy-%type-spawn))
      ("arm-event" name("click:cheatmenu/create-enemy/%type-vehicles"))
    }
  }
)

(define "enemy-infantry-wave"
  ("clone-enemy-infantry" tag("%faction_tx_at_01") waypoint(%waypoint))
  ("clone-enemy-infantry" tag("%faction_tx_sniper_01") waypoint(%waypoint))
  ("clone-enemy-infantry" tag("%faction_t4_01") waypoint(%waypoint))
  ("clone-enemy-infantry" tag("%faction_t4_02") waypoint(%waypoint))
  ("clone-enemy-infantry" tag("%faction_t4_03") waypoint(%waypoint))
  ("assign-to-enemy")
)

(define "enemy-infantry-spawn"
  ("enemy-infantry-wave" faction(%faction) waypoint(5600))
  {"delay"
    {time 5}
  }
  ("enemy-infantry-wave" faction(%faction) waypoint(5600))
  {"delay"
    {time 5}
  }
  ("enemy-infantry-wave" faction(%faction) waypoint(5600))
)

(define "enemy-light-wave"
  ("clone-enemy-vehicle" tag("%faction_light_1_enemy") waypoint(%waypoint))
  {"delay"
    {time 10}
  }
  ("clone-enemy-vehicle" tag("%faction_light_2_enemy") waypoint(%waypoint))
  {"delay"
    {time 10}
  }
  ("clone-enemy-vehicle" tag("%faction_light_3_enemy") waypoint(%waypoint))
)

(define "enemy-light-spawn"
  ("enemy-light-wave" faction(%faction) waypoint(5601))
)

(define "enemy-medium-wave"
  ("clone-enemy-vehicle" tag("%faction_medium_1_enemy") waypoint(%waypoint))
  {"delay"
    {time 10}
  }
  ("clone-enemy-vehicle" tag("%faction_medium_2_enemy") waypoint(%waypoint))
  {"delay"
    {time 10}
  }
  ("clone-enemy-vehicle" tag("%faction_medium_3_enemy") waypoint(%waypoint))
)

(define "enemy-medium-spawn"
  ("enemy-medium-wave" faction(%faction) waypoint(5602))
)

(define "enemy-heavy-wave"
  ("clone-enemy-vehicle" tag("%faction_heavy_1_enemy") waypoint(%waypoint))
  {"delay"
    {time 10}
  }
  ("clone-enemy-vehicle" tag("%faction_heavy_2_enemy") waypoint(%waypoint))
)

(define "enemy-heavy-spawn"
  ("enemy-heavy-wave" faction(%faction) waypoint(5603))
)

(define "enemy-all-spawn"
  ("enemy-infantry-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-infantry-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-infantry-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-light-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-medium-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-heavy-wave" faction(%faction) waypoint(5604))
  {"delay"
    {time 5}
  }
  ("enemy-infantry-wave" faction(%faction) waypoint(5604))
)

(define "enemy-human-passenger"
  {Human "mp/%faction/%type" 0x%id
    {TexMod %texmod}
  }
  {Tags "cheatmenu_enemy_passenger" 0x%id}
)

(define "enemy-vehicle-entity-2"
  {Entity "%type" 0x%id
    {TexMod %texmod}
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control AI}
      {fire_mode open}
      {move_mode free}
    }
  }

  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Tags "cheatmenu_enemy_spawned" "%faction_%tag_enemy" "%faction_%type_enemy" 0x%id}
)

(define "enemy-custom-entity-2"
  {Entity "%type" 0x%id
    {TexMod %texmod}
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control AI}
      {fire_mode open}
      {move_mode free}
    }
  }

  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  {Link 0x%crewOne {0x%id "%roleOne"}}
  {Link 0x%crewTwo {0x%id "%roleTwo"}}
  {Tags "cheatmenu_enemy_spawned" "%faction_%tag_enemy" "%faction_%type_enemy" 0x%id}
)

(define "enemy-vehicle-entity-3"
  {Entity "%type" 0x%id
    {TexMod %texmod}
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control AI}
      {fire_mode open}
      {move_mode free}
    }
  }

  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crewSupport) id(%crewThree) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Link 0x%crewThree {0x%id "%roleOne"}}
  {Tags "cheatmenu_enemy_spawned" "%faction_%tag_enemy" "%faction_%type_enemy" 0x%id}
)

(define "enemy-vehicle-entity-4"
  {Entity "%type" 0x%id
    {TexMod %texmod}
    {Player -1}
  }
  {Brain 0x%id
    {Properties
      {control AI}
      {fire_mode open}
      {move_mode free}
    }
  }

  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewOne) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crew) id(%crewTwo) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crewSupport) id(%crewThree) texmod(%texmod))
  ("enemy-human-passenger" faction(%faction) type(%crewSupport) id(%crewFour) texmod(%texmod))
  {Link 0x%crewOne {0x%id "driver"}}
  {Link 0x%crewTwo {0x%id "commander"}}
  {Link 0x%crewThree {0x%id "%roleOne"}}
  {Link 0x%crewFour {0x%id "%roleTwo"}}
  {Tags "cheatmenu_enemy_spawned" "%faction_%tag_enemy" "%faction_%type_enemy" 0x%id}
)


(define "enemy-squad-trigger-2"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-squad-trigger-3"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%three") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-squad-trigger-4"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%three") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%four") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-squad-trigger-5"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%three") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%four") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%five") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-squad-trigger-6"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%three") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%four") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%five") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%six") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)

(define "enemy-squad-trigger-8"
  {%event
    {condition
      {terms
        {"1.event"
          {id %event}
        }
      }
    }
    {actions
      ("reset-event" name(%event))
      ("clear-enemy-tags")
      ("clone-enemy-infantry" tag("%faction_%one") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%two") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%three") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%four") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%five") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%six") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%seven") waypoint(5606))
      ("clone-enemy-infantry" tag("%faction_%eight") waypoint(5606))
      ("assign-to-enemy")
      {"trigger"
        {name %event}
      }
    }
  }
)
